const express    = require('express');
const exec       = require('child_process').exec;

  //These functions clone the git repos of the explorviz-ui-backend, explorviz-ui-frontend and plugins for the backend once the server is started. 
  //The Urls for downloading are taken from the downloadFiles.json file.
  function initialize(downloadFiles){
    return initBackend(downloadFiles).then(function(downloadFiles){
      return initBackendPlugins(downloadFiles).then(function(downloadFiles){
        return initFrontend(downloadFiles)
      })
    })
  };


  function initBackend(downloadFiles){
    const backendName= 'explorviz-ui-backend';
    const downloadBackendURL = downloadFiles[backendName];

    return new Promise((resolve,reject)=>{
      exec('git clone ' + downloadBackendURL + ' '+ backendName, (error, stdout, stderr) => {

        if (error) {
          reject(error);
          return;
        }

        console.log(stdout);
        console.log(stderr);
      });
      resolve(downloadFiles);

    });
  }

  function initBackendPlugins(downloadFiles){
   downloadNames = Object.keys(downloadFiles);
   let pluginsFinished=0;

   const backendPlugins = downloadNames.filter(function(file){
    return /\bexplorviz-backend-plugin-\w*/.exec(file);
  });

   return new Promise((resolve, reject) => {
     if(backendPlugins.length !== 0 ){

      backendPlugins.forEach((pluginName) => {
        exec('git clone ' + downloadFiles[pluginName], (error, stdout, stderr) => {

          if (error) {
            reject(error);
            return;
          }

          console.log(stdout);
          console.log(stderr);
          pluginsFinished = pluginsFinished +1;

          if (backendPlugins.length == pluginsFinished){          
            resolve(downloadFiles);
          }
        });

      })
    } else {
      resolve(downloadFiles);
    }

  })
 }

 function initFrontend(downloadFiles){

  return new Promise((resolve,reject)=>{

    const frontendName ='explorviz-ui-frontend';
    const downloadFrontendURL = downloadFiles[frontendName];
    exec('git clone ' + downloadFrontendURL + ' ' + frontendName + ' && cd '+ frontendName + ' && npm install', (error, stdout, stderr) => {

      if (error) {
        reject(error);
        return;
      }

      console.log(stdout);
      console.log(stderr);
    });
    resolve();
    
  })

};

module.exports = {
  initialize
}