	const express    = require('express');
	const exec       = require('child_process').exec;		
	
//These functions handle everything regarding the backend of ExplorViz except adding it to the zip. Each will return a Promise.


function prepareClientFolder(clientName, fileName){
	return new Promise((resolve,reject)=>{

		exec('cp -R ' + fileName + '/ ' + clientName + '/',(error,stdout,stderr)=>{

			if (error) {
				reject(error);
				return;
			}

			console.log(stdout);
			console.log(stderr);

			resolve(fileName);

		})	
	})


}


//remove addons from former builds
function backendClean(clientName, fileName){

	return new Promise((resolve,reject)=>{
		const path= process.cwd()+'/' + clientName + '/explorviz-ui-backend/plugins/net/explorviz/';
		exec('rm -rf plugins/*',{cwd:path}, (error, stdout,stderr)=>{
			
			if (error) {
				reject(error);
				return;
			}

			console.log(stdout);
			console.log(stderr);

			resolve(fileName);

		})
	})
}

function backendPull(clientName, fileName){

	return new Promise((resolve, reject)=> {

		const path= process.cwd()+'/'+clientName + '/'+ fileName;
		exec('git pull ',{cwd:path} ,(error, stdout, stderr) => {
			
			if (error) {
				reject(error);
				return;
			}

			console.log(stdout);
			console.log(stderr);

			resolve();

		}); 
	})

}

function backendInstallAddons(checkedFiles,downloadFiles,clientName){

	return new Promise((resolve, reject)=>{
		let pluginsFinished=0;

		checkedPlugins = checkedFiles.filter(function(file){
			return /\bexplorviz-backend-plugin-\w*/.exec(file);
		});

		if(checkedPlugins.length !== 0 ){

			checkedPlugins.forEach((pluginName) => {
				
				const path= process.cwd()+'/'+ pluginName;
							exec('git pull ' + ' && rsync -av . ' + ' ../' + clientName +'/explorviz-ui-backend/plugins/net/explorviz/plugins/ ' + ' --exclude .git',{cwd:path}, (error, stdout, stderr) => { //'cd explorviz-ui-backend/plugins/net/explorviz/plugins/ ' + 
								
								if (error) {
									reject(error);
									return;
								}

								console.log(stdout);
								console.log(stderr);
								
								pluginsFinished = pluginsFinished +1;

								if (checkedPlugins.length == pluginsFinished){
									resolve();
								}
								
							});

						})
		} else {
			resolve();
		}

	})


}
function backendBuild(checkedFiles, clientName, fileName){

	return new Promise((resolve,reject)=>{

		
		
		const path= process.cwd()+'/'+clientName + '/' + fileName;
		exec('mvn compile war:war',{cwd:path}, (error,stdout,stderr)=> {
			

			if (error) {
				reject(error);
				return;
			}

			console.log(stdout);
			console.log(stderr);

			resolve({zipFileName:'backend.war', path: clientName + '/explorviz-ui-backend/target/explorviz-ui-backend-1.0-SNAPSHOT.war'});


		})

	})


}

module.exports = {
	prepareClientFolder,
	backendClean,
	backendPull,
	backendInstallAddons,
	backendBuild


}